/********************************************************************
 *   (C) Copyright OMRON Corporation 1995,1996, all rights reserved *
 ********************************************************************/

/* declarations of ad hoc text drawing functions for X11 */

/* Output Context: Status */
typedef struct _OutCStatRec	OutCStatRec, *OutCStat;
typedef struct _OutCListRec	OutCListRec, *OutCList;

/* Output Context */
typedef struct _OutCRec {
    /* generic functions to cut a string */
    OutCStat		(*init_conv)();
    int			(*do_conv)();
    void		(*term_conv)();
    /* specific functions for encoding scheme */
    int			(*getcode)();
    /* functions to query font */
    int			(*query_font)();
    XFontStruct		*default_fonts;		/* XXX */
    OutCList		xlfd_list;
    /* XXX: font cache will be placed here */
} OutCRec, *OutC;


/* Output functions */
extern int GxDrawString(
#if NeedFunctionPrototypes
    Display*	/* display */,
    Drawable	/* drawable */,
    OutC	/* outc */,
    GC		/* gc */,
    int		/* x */,
    int		/* y */,
    char*	/* string */,
    int		/* length */
#endif
);

extern int GxDrawImageString(
#if NeedFunctionPrototypes
    Display*	/* display */,
    Drawable	/* drawable */,
    OutC	/* outc */,
    GC		/* gc */,
    int		/* x */,
    int		/* y */,
    char*	/* string */,
    int		/* length */
#endif
);

extern int GxTextEscapement(
#if NeedFunctionPrototypes
    OutC	/* outc */,
    char*	/* string */,
    int		/* count */
#endif
);

extern OutC CreateOutC(
#if NeedFunctionPrototypes
    OutCList	/* xlfd_list */
#endif
);

extern XFontStruct *DefaultFontOfOutC(
#if NeedFunctionPrototypes
    OutC	/* outc */
#endif
);

extern OutCList add_list(
#if NeedFunctionPrototypes
    OutCList	/* list */,
    void*	/* object */
#endif
);


/* temporary functions */
extern OutC fi2oc(int);		/* defined in x11.h */

/* macros for Arena */
#define	AxwcDrawString(display, drawable, f, gc, x, y,			\
		       wstring, length)					\
	GxDrawString(display, drawable, fi2oc(f), gc, x, y,		\
		     (char*)(wstring), (length)*sizeof(wchar_t))
#define	AxwcDrawImageString(display, drawable, f, gc, x, y,		\
			    wstring, length)				\
	GxDrawImageString(display, drawable, fi2oc(f), gc, x, y,	\
			  (char*)(wstring), (length)*sizeof(wchar_t))
#define	AxwcTextEscapement(f, wstring, length)				\
	GxTextEscapement(fi2oc(f), (char*)(wstring), (length)*sizeof(wchar_t))
